﻿<AML>
 <Item type="Method" id="95FB01E006814FBE881701E06A9A36D6" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			acc_getAccountRecordForBankAcc
Created By		:		SolidCAD 
Creation Date:			2018-01-23
Description:
	-Checking Date
	-Checking Bank Account
	-Get Amount of choosing Bank Account and set.
	-Get all transaction of choosing Bank Account and set to Bank Reconciliation Details.
	
Hooks:
	Type:	Form	:	acc_BankReconciliation
	Event:	acc_bankaccount ( onChange )
	
	Type:	Form	:	acc_BankReconciliation
	Event:	acc_end_date ( onChange )
	
	Type:	Form	:	acc_BankReconciliation
	Event:	acc_start_date ( onChange )
	
Revisions:
	Rev Date		Modified By			Description
	YYYY-MM-DD		$username$			Initial creation
***************************************************************************** */

//debugger;
var myInnovator = new Innovator();
var thisItem = document.thisItem;

var fromDate = thisItem.getProperty('acc_start_date');
var toDate = thisItem.getProperty('acc_end_date');
var bankAccount = thisItem.getProperty('acc_bankaccount');
var acc_amount_currency;

if (fromDate > toDate) {
    alert('From Date is greater than To Date.Please Check!!');
} else {
    if (bankAccount === undefined) {
        alert('Must Be Fill Bank Account First!!');

    } 
    else {

        var sourceID = thisItem.getID();

        if (fromDate.length < 1) {
            alert('Choose Start Date!');
            handleItemChange("acc_bankaccount", '');
            return this;
        }
        if (toDate.length < 1) {
            alert('Choose End Date!');
            handleItemChange("acc_bankaccount", '');
            return this;
        }
        var getRelationships = thisItem.getRelationships("Acc_Bankreconciliation_Detail");
        var itemCount = getRelationships.getItemCount();
        if (itemCount > 0) {
            for (var i = 0; i < itemCount; i++) {
                var item = getRelationships.getItemByIndex(i);
                thisItem.removeRelationship(item);
            }
        }

        // refresh the grid
        var tabbar = parent.relationships.relTabbar;
        var tabID = tabbar.GetTabId("Bank Reconciliation Detail");
        parent.relationships.iframesCollection[tabID].contentWindow.doSearch(1);

        var openingbalancequery = "select top 1 (acc_amount_currency) from innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.SOURCE_ID= acc_journal_header.id where ACC_TRANSACTIONTYPE='Opening Balance' and acc_accountid='" + bankAccount + "' and  (Convert(Date,innovator.ConvertToLocal(acc_journal_header.acc_date,DEFAULT),111) Between Convert(Date,'" + fromDate + "',111) and Convert(Date,'" + toDate + "',111))";

        var getOpeningBalanceData = myInnovator.applySQL(openingbalancequery);

        var opcount = getOpeningBalanceData.getItemCount();

        var i = 0;
        for (i = 0; i < opcount; i++) {
            var item = getOpeningBalanceData.getItemByIndex(i);
            acc_amount_currency = item.getProperty("acc_amount_currency");

        }

        var sqlString = "select Transactionid = ap.id, [TransactionType] = 'Account Payable' ,[TransactionDate] = Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111),[TransactionNo] = acc_invoiceno,Deposit = 0,Withdraw = acc_payment,[Description] = 'Cash Payment to ' + VENDOR.name From innovator.acc_journal_header j inner join innovator.acc_accountpayable ap on ap.acc_referenceno=j.acc_refno join innovator.acc_accountpayable_detail apd on apd.source_id = ap.id left join innovator.vendor on vendor.id = ap.acc_vendor where  acc_cash_account = '" + bankAccount + "' and (Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111) Between Convert(Date,'" + fromDate + "',111) and  Convert(Date,'" + toDate + "',111)) union all select Transactionid = ar.id, [TransactionType] = 'Account Recievable' ,[TransactionDate] = Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111),[TransactionNo] =	acc_invoice_no,Deposit = acc_payment,Widthdraw = 0,[Description] = 'Cash Receivable  From ' + customer.name From innovator.acc_journal_header j join innovator.acc_accountsreceivable ar on ar.acc_reference_no=j.acc_refno join innovator.acc_accountsreceivabledetail ard on ard.source_id = ar.id left join innovator.customer on customer.id = ar.acc_customer where  acc_cash_account = '" + bankAccount + "' and (Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111) Between Convert(Date,'" + fromDate + "',111) and  Convert(Date,'" + toDate + "',111)) union all select Transactionid = ie.id, [TransactionType] = 'Income' ,[TransactionDate] =Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111),[TransactionNo] = ie.acc_reference_no,Deposit = ied.acc_amount,Widthdraw = 0,[Description] = acc.acc_accountdetail_name  From innovator.acc_journal_header j  inner join innovator.acc_income_expense_header ie on ie.acc_reference_no=j.acc_refno join innovator.acc_income_expense_detail ied on ied.source_id = ie.id join innovator.acc_accountdetails acc on acc.id = ied.acc_account_no where ie.acc_type = 'Income' and  ie.acc_cash_account = '" + bankAccount + "'  and  (Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111) Between Convert(Date,'" + fromDate + "',111) and  Convert(Date,'" + toDate + "',111)) union all select Transactionid = ie.id, [TransactionType] = 'Expense' ,[TransactionDate] = Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111),[TransactionNo] = ie.acc_reference_no,Deposit = 0,Widthdraw = ied.acc_amount,[Description] = acc.acc_accountdetail_name From innovator.acc_journal_header j  inner join innovator.acc_income_expense_header ie on ie.acc_reference_no=j.acc_refno join innovator.acc_income_expense_detail ied on ied.source_id = ie.id join innovator.acc_accountdetails acc on acc.id = ied.acc_account_no where ie.acc_type = 'Expense' and  ie.acc_cash_account = '" + bankAccount + "'  and  (Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111) Between Convert(Date,'" + fromDate + "',111) and  Convert(Date,'" + toDate + "',111)) union all select  Transactionid = j.id, [TransactionType] = 'Journal',[TransactionDate] =Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111), [TransactionNo] = j.acc_journal_no ,Deposit = acc_amount_currency, Withdraw = 0,[Description] ='Capital Reserve' From innovator.acc_journal_details jd join innovator.acc_journal_header j on j.id = jd.source_id join innovator.acc_accountdetails acc on acc.id = jd.acc_accountid where jd.source_id in ( select id from (select id,acc_date from (select top 1 j.id,acc_date From innovator.acc_journal_header j join innovator.acc_journal_details jd   on j.id = jd.source_id where  j.is_current = 1 and jd.acc_accountid = '" + bankAccount + "' and acc_transactiontype='Opening Balance' and (Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111) Between Convert(Date,'" + fromDate + "',111) and  Convert(Date,'" + toDate + "',111))) as reult) as result_one ) and acc_accountid in ('" + bankAccount + "') and (Convert(Date,innovator.ConvertToLocal(j.acc_date,DEFAULT),111) Between Convert(Date,'" + fromDate + "',111) and  Convert(Date,'" + toDate + "',111))";

        var getData = inno.applySQL(sqlString);
        var count = getData.getItemCount();
        var i = 0;
        for (i = 0; i < count; i++) {
            var item = getData.getItemByIndex(i);
            var TransactionID = item.getProperty("transactionid");
            var TransactionType = item.getProperty("transactiontype");
            var TransactionDate = item.getProperty("transactiondate");

            var TransactionNo = item.getProperty("transactionno");
            var Deposit = item.getProperty("deposit");
            var Widthdraw = item.getProperty("withdraw");
            var Description = item.getProperty("description");
            if (TransactionType !== "Journal") {
                acc_amount_currency = parseFloat(acc_amount_currency) + parseFloat(Deposit);
                acc_amount_currency = parseFloat(acc_amount_currency) - parseFloat(Widthdraw);
            }

            TransactionDate = new Date(TransactionDate);
            TransactionDate = pad(TransactionDate.getFullYear()) + '-' + pad(TransactionDate.getMonth() + 1) + '-' + pad(TransactionDate.getDate()) + 'T' + pad(TransactionDate.getHours()) + ':' + pad(TransactionDate.getMinutes()) + ':' + pad(TransactionDate.getSeconds());
            var checkTransaction = myInnovator.applySQL("select * From innovator.Acc_Bankreconciliation_Detail where acc_transactionid = '" + TransactionID + "'");
            if (checkTransaction.getItemCount() < 1) {
                var addBankReconcilDetail = myInnovator.newItem("Acc_Bankreconciliation_Detail", "add");
                addBankReconcilDetail.setProperty("acc_transactionid", TransactionID);
                addBankReconcilDetail.setProperty("acc_transactiontype", TransactionType);
                addBankReconcilDetail.setProperty("acc_invoicedate", TransactionDate);
                addBankReconcilDetail.setProperty("acc_refinvoiceno", TransactionNo);
                addBankReconcilDetail.setProperty("acc_deposits", Deposit);
                addBankReconcilDetail.setProperty("acc_withdrawls", Widthdraw);
                addBankReconcilDetail.setProperty("acc_description", Description);
                addBankReconcilDetail.setProperty("source_id", sourceID);
                addBankReconcilDetail.setProperty("acc_reconciled", "0");
                addBankReconcilDetail.apply();
                document.thisItem.addRelationship(addBankReconcilDetail);
                document.thisItem.setAttribute("isDirty", "1");
            }

        }
        if (acc_amount_currency === undefined) {
            handleItemChange("acc_account_balance", "0.00");
        } else {
            handleItemChange("acc_account_balance", acc_amount_currency);
        }
    }
}
function pad(x) {
    return (x < 10) ? "0" + x : "" + x;
}

parent.onRefresh();]]></method_code>
  <method_type>JavaScript</method_type>
  <name>acc_getAccountRecordForBankAcc</name>
 </Item>
</AML>